Store Class Referenceabstract

Acts as a Source for pre-existing, static data. More...

Inheritance diagram for Store:

## Public Member Functions

| Store ()
| Construct a Store.
void | IsolatedInitialize (const NameValuePairs &parameters)
| Initialize or reinitialize this object, without signal propagation. More...
unsigned int | NumberOfMessages () const
| Provides the number of meesages processed by this object. More...
bool | GetNextMessage ()
| Start retrieving the next message. More...
unsigned int | CopyMessagesTo (BufferedTransformation &target, unsigned int count=UINT_MAX, const std::string &channel=DEFAULT_CHANNEL) const
Public Member Functions inherited from AutoSignaling< InputRejecting< BufferedTransformation > >
| AutoSignaling (int propagation=-1)
void | SetAutoSignalPropagation (int propagation)
int | GetAutoSignalPropagation () const
Public Member Functions inherited from InputRejecting< BufferedTransformation >
size_t | Put2 (const byte *inString, size_t length, int messageEnd, bool blocking)
| Input a byte array for processing. More...
bool | IsolatedFlush (bool hardFlush, bool blocking)
bool | IsolatedMessageSeriesEnd (bool blocking)
size_t | ChannelPut2 (const std::string &channel, const byte *inString, size_t length, int messageEnd, bool blocking)
bool | ChannelMessageSeriesEnd (const std::string &channel, int messageEnd, bool blocking)
Public Member Functions inherited from BufferedTransformation
| BufferedTransformation ()
| Construct a BufferedTransformation.
BufferedTransformation & | Ref ()
| Provides a reference to this object. More...
size_t | Put (byte inByte, bool blocking=true)
| Input a byte for processing. More...
size_t | Put (const byte *inString, size_t length, bool blocking=true)
| Input a byte buffer for processing. More...
size_t | PutWord16 (word16 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| Input a 16-bit word for processing. More...
size_t | PutWord32 (word32 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| Input a 32-bit word for processing. More...
virtual byte * | CreatePutSpace (size_t &size)
| Request space which can be written into by the caller. More...
virtual bool | CanModifyInput () const
| Determines whether input can be modifed by the callee. More...
size_t | PutModifiable (byte *inString, size_t length, bool blocking=true)
| Input multiple bytes that may be modified by callee. More...
bool | MessageEnd (int propagation=-1, bool blocking=true)
| Signals the end of messages to the object. More...
size_t | PutMessageEnd (const byte *inString, size_t length, int propagation=-1, bool blocking=true)
| Input multiple bytes for processing and signal the end of a message. More...
virtual size_t | PutModifiable2 (byte *inString, size_t length, int messageEnd, bool blocking)
| Input multiple bytes that may be modified by callee. More...
unsigned int | GetMaxWaitObjectCount () const
| Retrieves the maximum number of waitable objects.
void | GetWaitObjects (WaitObjectContainer &container, CallStack const &callStack)
| Retrieves waitable objects. More...
virtual void | Initialize (const NameValuePairs &parameters=g_nullNameValuePairs, int propagation=-1)
| Initialize or reinitialize this object, with signal propagation. More...
virtual bool | Flush (bool hardFlush, int propagation=-1, bool blocking=true)
| Flush buffered input and/or output, with signal propagation. More...
virtual bool | MessageSeriesEnd (int propagation=-1, bool blocking=true)
| Marks the end of a series of messages, with signal propagation. More...
virtual int | GetAutoSignalPropagation () const
| Retrieve automatic signal propagation value. More...
virtual lword | MaxRetrievable () const
| Provides the number of bytes ready for retrieval. More...
virtual bool | AnyRetrievable () const
| Determines whether bytes are ready for retrieval. More...
virtual size_t | Get (byte &outByte)
| Retrieve a 8-bit byte. More...
virtual size_t | Get (byte *outString, size_t getMax)
| Retrieve a block of bytes. More...
virtual size_t | Peek (byte &outByte) const
| Peek a 8-bit byte. More...
virtual size_t | Peek (byte *outString, size_t peekMax) const
| Peek a block of bytes. More...
size_t | GetWord16 (word16 &value, ByteOrder order=BIG_ENDIAN_ORDER)
| Retrieve a 16-bit word. More...
size_t | GetWord32 (word32 &value, ByteOrder order=BIG_ENDIAN_ORDER)
| Retrieve a 32-bit word. More...
size_t | PeekWord16 (word16 &value, ByteOrder order=BIG_ENDIAN_ORDER) const
| Peek a 16-bit word. More...
size_t | PeekWord32 (word32 &value, ByteOrder order=BIG_ENDIAN_ORDER) const
| Peek a 32-bit word. More...
lword | TransferTo (BufferedTransformation &target, lword transferMax=LWORD_MAX, const std::string &channel=DEFAULT_CHANNEL)
| move transferMax bytes of the buffered output to target as input More...
virtual lword | Skip (lword skipMax=LWORD_MAX)
| Discard skipMax bytes from the output buffer. More...
lword | CopyTo (BufferedTransformation &target, lword copyMax=LWORD_MAX, const std::string &channel=DEFAULT_CHANNEL) const
| copy copyMax bytes of the buffered output to target as input More...
lword | CopyRangeTo (BufferedTransformation &target, lword position, lword copyMax=LWORD_MAX, const std::string &channel=DEFAULT_CHANNEL) const
| Copy bytes from this object using an index to another BufferedTransformation. More...
virtual lword | TotalBytesRetrievable () const
| Provides the number of bytes ready for retrieval. More...
virtual bool | AnyMessages () const
| Determines if any messages are available for retrieval. More...
virtual unsigned int | SkipMessages (unsigned int count=UINT_MAX)
| Skip a number of meessages. More...
unsigned int | TransferMessagesTo (BufferedTransformation &target, unsigned int count=UINT_MAX, const std::string &channel=DEFAULT_CHANNEL)
| Transfer messages from this object to another BufferedTransformation. More...
unsigned int | CopyMessagesTo (BufferedTransformation &target, unsigned int count=UINT_MAX, const std::string &channel=DEFAULT_CHANNEL) const
| Copy messages from this object to another BufferedTransformation. More...
virtual void | SkipAll ()
| Skip all messages in the series.
void | TransferAllTo (BufferedTransformation &target, const std::string &channel=DEFAULT_CHANNEL)
| Transfer all bytes from this object to another BufferedTransformation. More...
void | CopyAllTo (BufferedTransformation &target, const std::string &channel=DEFAULT_CHANNEL) const
| Copy messages from this object to another BufferedTransformation. More...
virtual bool | GetNextMessageSeries ()
| Retrieve the next message in a series. More...
virtual unsigned int | NumberOfMessagesInThisSeries () const
| Provides the number of messages in a series. More...
virtual unsigned int | NumberOfMessageSeries () const
| Provides the number of messages in a series. More...
virtual size_t | TransferTo2 (BufferedTransformation &target, lword &byteCount, const std::string &channel=DEFAULT_CHANNEL, bool blocking=true)=0
| Transfer bytes from this object to another BufferedTransformation. More...
virtual size_t | CopyRangeTo2 (BufferedTransformation &target, lword &begin, lword end=LWORD_MAX, const std::string &channel=DEFAULT_CHANNEL, bool blocking=true) const =0
| Copy bytes from this object to another BufferedTransformation. More...
size_t | TransferMessagesTo2 (BufferedTransformation &target, unsigned int &messageCount, const std::string &channel=DEFAULT_CHANNEL, bool blocking=true)
| Transfer messages from this object to another BufferedTransformation. More...
size_t | TransferAllTo2 (BufferedTransformation &target, const std::string &channel=DEFAULT_CHANNEL, bool blocking=true)
| Transfer all bytes from this object to another BufferedTransformation. More...
size_t | ChannelPut (const std::string &channel, byte inByte, bool blocking=true)
| Input a byte for processing on a channel. More...
size_t | ChannelPut (const std::string &channel, const byte *inString, size_t length, bool blocking=true)
| Input a byte buffer for processing on a channel. More...
size_t | ChannelPutModifiable (const std::string &channel, byte *inString, size_t length, bool blocking=true)
| Input multiple bytes that may be modified by callee on a channel. More...
size_t | ChannelPutWord16 (const std::string &channel, word16 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| Input a 16-bit word for processing on a channel. More...
size_t | ChannelPutWord32 (const std::string &channel, word32 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| Input a 32-bit word for processing on a channel. More...
bool | ChannelMessageEnd (const std::string &channel, int propagation=-1, bool blocking=true)
| Signal the end of a message. More...
size_t | ChannelPutMessageEnd (const std::string &channel, const byte *inString, size_t length, int propagation=-1, bool blocking=true)
| Input multiple bytes for processing and signal the end of a message. More...
virtual byte * | ChannelCreatePutSpace (const std::string &channel, size_t &size)
| Request space which can be written into by the caller. More...
virtual size_t | ChannelPutModifiable2 (const std::string &channel, byte *inString, size_t length, int messageEnd, bool blocking)
| Input multiple bytes that may be modified by callee on a channel. More...
virtual bool | ChannelFlush (const std::string &channel, bool hardFlush, int propagation=-1, bool blocking=true)
| Flush buffered input and/or output on a channel. More...
virtual void | SetRetrievalChannel (const std::string &channel)
| Sets the default retrieval channel. More...
virtual bool | Attachable ()
| Determines whether the object allows attachment. More...
virtual BufferedTransformation * | AttachedTransformation ()
| Returns the object immediately attached to this object. More...
virtual const BufferedTransformation * | AttachedTransformation () const
| Returns the object immediately attached to this object. More...
virtual void | Detach (BufferedTransformation *newAttachment=0)
| Delete the current attachment chain and attach a new one. More...
virtual void | Attach (BufferedTransformation *newAttachment)
| Add newAttachment to the end of attachment chain. More...
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms. More...
virtual std::string | AlgorithmName () const
| Provides the name of this algorithm. More...
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object. More...
Public Member Functions inherited from Waitable
bool | Wait (unsigned long milliseconds, CallStack const &callStack)
| Wait on this object. More...

## Additional Inherited Members

Static Public Attributes inherited from BufferedTransformation
static const std::string & | NULL_CHANNEL = DEFAULT_CHANNEL

## Detailed Description

Acts as a Source for pre-existing, static data.

Template Parameters

  T | the class or type

A BufferedTransformation that only contains pre-existing data as "output"

Definition at line 244 of file simple.h.

## Member Function Documentation

## IsolatedInitialize()

void Store::IsolatedInitialize | ( | const NameValuePairs & | parameters | ) |

inline virtual

Initialize or reinitialize this object, without signal propagation.

Parameters

  parameters | a set of NameValuePairs to initialize this object

Exceptions

  NotImplemented |

IsolatedInitialize() is used to initialize or reinitialize an object using a variable number of arbitrarily typed arguments. The function avoids the need for multiple constuctors providing all possible combintations of configurable parameters.

IsolatedInitialize() does not call Initialize() on attached transformations. If initialization should be propagated, then use the Initialize() function.

If a derived class does not override IsolatedInitialize(), then the base class throws NotImplemented.

Reimplemented from BufferedTransformation.

Definition at line 250 of file simple.h.

## NumberOfMessages()

unsigned int Store::NumberOfMessages | ( |  | ) | const

inline virtual

Provides the number of meesages processed by this object.

Returns
  the number of meesages processed by this object

NumberOfMessages returns number of times MessageEnd() has been received minus messages retrieved or skipped

Reimplemented from BufferedTransformation.

Definition at line 256 of file simple.h.

## GetNextMessage()

bool Store::GetNextMessage | ( |  | ) |

virtual

Start retrieving the next message.

Returns
  true if a message is ready for retrieval

GetNextMessage() returns true if a message is ready for retrieval; false if no more messages exist or this message is not completely retrieved.

Reimplemented from BufferedTransformation.

Definition at line 1071 of file filters.cpp.

The documentation for this class was generated from the following files:

- simple.h
- filters.cpp